Ext.define('DSS.addon.IlluminantTest', {
    extend : 'DSS.component.Base',
    mixins : {
        observable : 'Ext.util.Observable'
    },
    topPanel:null,
    topLabel:null,
    grafic : null,
    middlePanel : null,
    sliderPanel:null,
    buttonPanel:null,
    btnSend:null,
    btnTest:null,
    iDefaultWidth : 150,
    iDefaultHeight : 293,
    nFieldPercent:null,
    nFieldSlider:null,
    btnMin:null,
    btnMax:null,
    btnInc:null,
    btnDec:null,
    btnMid:null,
    setHeight : function(oHeight) {
        this.middlePanel.setHeight(oHeight -60);
        this.buttonPanel.setHeight(oHeight -60);
        this.grafic.setHeight(oHeight -60);
        this.sliderPanel.setHeight(oHeight -60);
        this.nFieldSlider.setHeight(oHeight -90);
        this.iDefaultHeight = oHeight - 62;
        this.callParent(arguments);
    },
    setSlider:function(value) {
        if (value>100)
            value=100;
        if (value<0)
            value=0;
        this.nFieldPercent.setValue(value);
        this.nFieldSlider.setValue(value);
                
        if (this.dssEditor.editControls.device.isValid())
        {
            var sSelected=this.dssEditor.editControls.device.getValue();
            dss.raiseEvent('led-wizard',{actions:'setValue',dsid:sSelected,value:Math.floor((value*255)/100)});
        }
    },
    setIllumantLabel:function (value) {
        this.topLabel.setValue(value);
    },
    initStores : function() {
        if (Ext.data.StoreManager.lookup('illuminateChartValues') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'illuminateChartValues',
                fields : [ 'id','value'],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });   
        }
    },
    constructor : function(config) {
        this.initStores();
        var me = this;
        this.btnSend=Ext.create('Ext.Button',{
            text:_('Send Dimmcurve'),
            handler: function () {                
                if (me.dssEditor.editControls.device.isValid())
                    if (me.dssEditor.editControls.type.isValid())
                    {
                        dss.raiseEvent('led-wizard',{actions:'setValuesFromCatalog',dsid:me.dssEditor.editControls.device.getValue(),legal:false,catid:me.dssEditor.editControls.type.getValue()});
                        var oWait=Ext.Msg.wait(_('Please wait for transmitting the data'));
                        
                        var iSubscriptID = Math.floor(Math.random() * 100000000000);
                        dss.ajaxSyncRequest('/json/event/subscribe', {
                            subscriptionID : iSubscriptID,
                            name : 'led-wizard.answer'
                        });
                        dss.ajaxAssyncRequestWithoutAnswer('/json/event/get', {
                            subscriptionID : iSubscriptID,
                            timeout : 60 * 1000
                        }, function(DochAnswer) {
                            var result=Ext.JSON.decode(DochAnswer);
                            dss.ajaxAssyncRequestWithoutAnswer('/json/event/unsubscribe', {
                                subscriptionID : iSubscriptID,
                                name : 'led-wizard.answer'
                            });
                            oWait.close();
                            if (result.result.events[0]!=null) {
                                if (result.result.events[0].properties.result=='false') {
                                    Ext.Msg.alert(_('Not completed'),_('The transmission of the data was not succesfully completed'));
                                } else {
                                    Ext.Msg.alert('',_('The transmission of the data was succesfully completed'));
                                }
                            }
                        });
                }
            }
        });
        this.btnReset=Ext.create('Ext.Button',{
            text:_('Reset Dimmcurve'),
            margin: '0 70 0 70',
            handler: function () {                
                if (me.dssEditor.editControls.device.isValid())
                    if (me.dssEditor.editControls.type.isValid())
                    {
                        dss.raiseEvent('led-wizard',{actions:'setValuesFromCatalog',dsid:me.dssEditor.editControls.device.getValue(),legal:false,catid:0});
                        var oWait=Ext.Msg.wait(_('Please wait for transmitting the data'));
                        
                        var iSubscriptID = Math.floor(Math.random() * 100000000000);
                        dss.ajaxSyncRequest('/json/event/subscribe', {
                            subscriptionID : iSubscriptID,
                            name : 'led-wizard.answer'
                        });
                        dss.ajaxAssyncRequestWithoutAnswer('/json/event/get', {
                            subscriptionID : iSubscriptID,
                            timeout : 60 * 1000
                        }, function(DochAnswer) {
                            var result=Ext.JSON.decode(DochAnswer);
                            dss.ajaxAssyncRequestWithoutAnswer('/json/event/unsubscribe', {
                                subscriptionID : iSubscriptID,
                                name : 'led-wizard.answer'
                            });
                            oWait.close();
                            if (result.result.events[0]!=null) {
                                if (result.result.events[0].properties.result=='false') {
                                    Ext.Msg.alert(_('Not completed'),_('The transmission of the data was not succesfully completed'));
                                } else {
                                    Ext.Msg.alert('',_('The transmission of the data was succesfully completed'));
                                }
                            }
                        });
                }
            }
        });
        this.btnTest=Ext.create('Ext.Button',{
            text:_('Test Dimmcurve'),
            handler: function () {
                if (me.dssEditor.editControls.device.isValid())
                {
                    var sSelected=me.dssEditor.editControls.device.getValue();
                    dss.raiseEvent('led-wizard',{actions:'startDemoModus',dsid:sSelected});
                }                
            }
        });
        this.btnMax=Ext.create('Ext.Button',{
            text:_('Max'),
            width:46,
            margin: '0 0 10 0',
            handler: function() {
                me.setSlider(100);
            }
        });
        this.btnInc = Ext.create('Ext.button.Button', {
            iconCls : 'my-icon-up-action',
            iconAlign: "top",
            id:'incButtonWeilsSoSchlechtZuPositionierenIst',
            width:46,
            margin: '0 0 10 0',
            handler: function() {
                me.setSlider(me.nFieldSlider.getValue()+10);
            }
        });
        this.btnMid=Ext.create('Ext.Button',{
            text:_('50%'),
            width:46,
            margin: '0 0 10 0',
            handler: function() {
                me.setSlider(50);
            }
        });
        this.btnDec = Ext.create('Ext.button.Button', {
            iconCls : 'my-icon-down-action',
            iconAlign: "top",
            id:'decButtonWeilsSoSchlechtZuPositionierenIst',
            width:46,
            margin: '0 0 10 0',
            handler: function() {
                me.setSlider(me.nFieldSlider.getValue()-10);
            }
        });
        this.btnMin=Ext.create('Ext.Button',{
            text:_('Min'),
            width:46,
            margin: '0 0 14 0',
            handler: function() {
                me.setSlider(0);
            }
        });
        this.topPanel=Ext.create('Ext.panel.Panel',{
            layout : {
                type : 'hbox'
            },
            width:750,
            height:30,
            align:'middle',
            border:0,
            items:[this.btnSend,this.btnReset,this.btnTest]
        });
        this.topLabel=Ext.create('Ext.form.field.Display',{
            fieldLabel:_('illuminant'),
            width:750,
            value:'Wert'
        });
        this.nFieldPercent=Ext.create('Ext.form.field.Number',{
            minValue:0,
            maxValue:100,
            step:1,
            decimalPrecision:0,
            width:50,
            listeners: {
                change: function(field,value) {
                    me.setSlider(value);
                }
            }
        });
        this.nFieldSlider=Ext.create('Ext.slider.Single', {
            width: 50,
            value: 50,
            increment: 1,
            minValue: 0,
            maxValue: 100,
            vertical:true,
            padding : "0 0 0 10",
            listeners: {
                change: function(field,value) {
                    me.setSlider(value);
                }
            }
        });
        this.grafic = Ext.create('Ext.chart.Chart', {
            store:Ext.data.StoreManager.lookup('illuminateChartValues'),
            height : 200,
            width: 650,
            animate: true,
            series: [ {
                         type: 'line',
                         xField: 'id',
                         yField: 'value',
                         fill: true,
                         markerConfig: {
                             type: 'circle',
                             radius: 4,
                             'fill': '#ffff00'
                         }
                     }]
        });
        this.sliderPanel=Ext.create('Ext.panel.Panel',{
            layout:{type:'vbox'}, 
            width:50,
            border:0,
            items:[this.nFieldSlider,this.nFieldPercent]
        });
        this.buttonPanel=Ext.create('Ext.panel.Panel',{
            layout : {
                type : 'vbox',
                align:'center',
                pack:'center'
            },
            border:0,
            width:50,
            items:[this.btnMax,this.btnInc,this.btnMid,this.btnDec,this.btnMin]
        });
        this.middlePanel=Ext.create('Ext.panel.Panel',{
            layout : {
                type : 'hbox'
            },
            width:750,
            height:200,
            border:0,
            items:[this.grafic,this.sliderPanel, this.buttonPanel]
        });
        Ext.apply(this, {
            layout : {
                type : 'vbox'
            },
            padding: '0 0 0 10',
            items : [this.topLabel,this.topPanel, this.middlePanel ]
        });
        this.callParent(arguments);
    },
    reset : function() {
    },
    setValue : function(value) {
    },
    isValid : function() {
        return true;
    },
    getValue : function() {
    }
});
